package
{
	import com.greensock.TweenMax;
	import com.greensock.easing.Linear;
	
	import flashx.textLayout.formats.Float;
	
	import mx.utils.StringUtil;
	
	import org.flixel.FlxG;
	import org.flixel.FlxObject;
	import org.flixel.FlxPath;
	import org.flixel.FlxPoint;
	import org.flixel.FlxSprite;

	public class Game
	{
		//>1 = passable	
		public var map:Vector.<Vector.<int>>;
		public var blocks:Vector.<BlockDat>;
		public var player:EntDat;
		public var number:String;
		
		public function generatenumber():void
		{
			var numlen:int = blocks.length;
			number="";;
			for (var i:int=0;i<numlen;i++)
			{
				var num:int = int(Math.random()*10);
				if (num>=10)
					num=0;
				number+=num.toString();	
			}			
		}
		
		public function MapString():String
		{
			var s:String="";
			for(var i:int=0;i<map.length;i++)
			{
				if (i>0)
					s+="\n";
				
				for (var j:int=0;j<map[i].length;j++)
				{
					if (j>0)
						s+=",";
					
					s+=map[i][j];
					
				}
			}
			return s;
		}						
		
		public function ClearMoved():void
		{
			for each(var ed:BlockDat in blocks)
			{
				ed.moved=FlxObject.NODIR;
				ed.trymoved=false;
			}
			player.moved=FlxObject.NODIR;
			player.trymoved=false;
		}
		
		public var progress:int=0;
		public var endtile:BlockDat;
		
		function Game(desc:String="")
		{
			progress=0;
			map = new Vector.<Vector.<int>>();
			blocks = new Vector.<BlockDat>();
			player = new EntDat(-1,-1,FlxObject.NODIR);
			
			if (desc=="")
				return;
			
			var ar:Array = desc.split("\n");
			for (var i:int=0;i<ar.length;i++)
			{
				var row:Vector.<int> = new Vector.<int>();
				var s:String = ar[i];				
				s = mx.utils.StringUtil.trim(s);
				for (var j:int=0;j<s.length;j++)
				{
					switch(s.charAt(j))
					{
						case "#":
							row.push(1);
							break;
						case " ":
							row.push(2);
							break;
						case "C":
							row.push(2);
							endtile = new BlockDat(j,i);
						case "a":
							row.push(2);
							blocks.push(new BlockDat(j,i));
							break;
						case "U":
							player = new EntDat(j,i,FlxObject.UP);
							row.push(2);
							break;
						case "D":
							player = new EntDat(j,i,FlxObject.DOWN);
							row.push(2);
							break;
						case "L":
							player = new EntDat(j,i,FlxObject.LEFT);
							row.push(2);
							break;
						case "R":
							player = new EntDat(j,i,FlxObject.RIGHT);
							row.push(2);
							break;
					}
				}
				map.push(row);
			}
		}
		
		private function TileMapBlocks(x:int,y:int):Boolean
		{
			if (x<0 || y<0 || x>=map.length || y>=map[0].length)
				return true;
			return map[y][x]<=1;
		}
		
		private function GetBlock(x:int,y:int):BlockDat
		{
			for each (var bd:BlockDat in blocks)
			{
				if (bd.x==x&&bd.y==y)
					return bd;
			}
			return null;
		}
		
		public var needsupdate:Boolean;
		
		public function TryMove(ed:EntDat, dir:uint,playerpushing:Boolean):Boolean
		{		
		
			
			if (ed.trymoved)
			{				
				return dir==ed.moved;
			}
			
			var dirchanged:Boolean=player.direction!=dir;
			
			player.direction=dir;
			
			var tx:int=ed.x;
			var ty:int=ed.y;
			switch(dir)
			{
				case FlxObject.UP:
					ty--;
					break;
				case FlxObject.DOWN:
					ty++;
					break;
				case FlxObject.LEFT:
					tx--;
					break;
				case FlxObject.RIGHT:
					tx++;
					break;
			}
			
			var tilemapblocked:Boolean = TileMapBlocks(tx,ty);
			if (tilemapblocked==true)
			{
				return dirchanged;
			}
			
			var bd:BlockDat = GetBlock(tx,ty);
			
			if (bd!=null)
			{
				
				if (playerpushing && bd.spokento==false)
				{
					bd.spokento=true;
					progress++;
					needsupdate=true;
				}
				
				if (TryMove(bd,dir,false)==false)
				{
					return dirchanged;
				}
				else
				{
					
				}
			}
					
			//success! do stuff!
			
			
			ed.moved=dir;
			
			ed.trymoved=true;			
			//ed.x=tx;
			//ed.y=ty;
			needsupdate=true;
			return true;
	
		}
		
		public function ProcessMoves():Boolean
		{
			ProcessMove(player);
			for each(var bd:BlockDat in blocks)
			{
				ProcessMove(bd);
			}
			
			
			TrySpeak();
			
			return CheckWin();
		}
		
		private function CheckWin():Boolean
		{			
			if (endtile!=null)
			{
				return endtile.x == player.x && endtile.y==player.y;
			}
			return (progress==blocks.length);
		}
		
		private function ProcessMove(e:EntDat):void
		{
			switch(e.moved)
			{
				case FlxObject.NODIR:
					break;
				case FlxObject.UP:
					e.y--;
					break;
				case FlxObject.DOWN:
					e.y++;
					break;
				case FlxObject.LEFT:
					e.x--;
					break;
				case FlxObject.RIGHT:
					e.x++;
					break;
			}
		}
		
		public var movedur:Number = 0.2;
		public static var tilesize:int=10;
		
		public function TrySpeak()
		{
			/*
			var tx:int=player.x;
			var ty:int=player.y;
			switch(player.direction)
			{
				case FlxObject.UP:
					ty--;
					break;
				case FlxObject.DOWN:
					ty++;
					break;
				case FlxObject.LEFT:
					tx--;
					break;
				case FlxObject.RIGHT:
					tx++;
					break;
			}
			var target:BlockDat = GetBlock(tx,ty);
			if (target!=null)
			{
				if (target.spokento==false)
				{
					target.spokento=true;
					progress++;
				}
			}*/
		}
		public function GenSprites() : Vector.<FlxSprite>
		{
			var result:Vector.<FlxSprite> = new Vector.<FlxSprite>();
			for each ( var bd:BlockDat in blocks)
			{
				var s:FlxSprite = new FlxSprite(bd.x*tilesize,bd.y*tilesize);
				s.loadGraphic(GameState.ImgRock,true,false,tilesize,tilesize);
				s.addAnimation("a",[0],0,false);
				s.addAnimation("b",[1],0,false);
				s.play(bd.spokento?"a":"b");
				TryTween(s,bd);
				result.push(s);
			}
			
			var p:FlxSprite = new FlxSprite(player.x*tilesize,player.y*tilesize);
			p.loadGraphic(GameState.ImgPlayer,true,false,tilesize,tilesize);
			p.addAnimation(FlxObject.UP.toString(),[3,3+4],2,true);
			p.addAnimation(FlxObject.DOWN.toString(),[0,0+4],2,true);
			p.addAnimation(FlxObject.LEFT.toString(),[1,1+4],2,true);
			p.addAnimation(FlxObject.RIGHT.toString(),[2,2+4],2,true);
			p.play(player.direction.toString());
			TryTween(p,player);
			result.push(p);
			
			if (endtile!=null)
			{
				var et:FlxSprite = new FlxSprite(bd.x*tilesize,bd.y*tilesize);
				et.loadGraphic(GameState.ImgShack,true,false,tilesize,tilesize);
				result.push(et);
			}
			
			return result;
		}
		
		private function TryTween(s:FlxSprite,ed:EntDat):void
		{			
			switch (ed.moved)
			{
				case FlxObject.NODIR:
					break;
				case FlxObject.UP:					
					TweenMax.from(s,movedur,{x:s.x,y:s.y+tilesize});
					break;
				case FlxObject.DOWN:
					TweenMax.from(s,movedur,{x:s.x,y:s.y-tilesize});
					break;
				case FlxObject.LEFT:
					TweenMax.from(s,movedur,{x:s.x+tilesize,y:s.y});
					break;
				case FlxObject.RIGHT:
					TweenMax.from(s,movedur,{x:s.x-tilesize,y:s.y});
					break;				
			}	
		}
		
		public function Copy():Game
		{
			var g:Game = new Game();
			g.endtile=endtile;
			for (var i:int=0;i<map.length;i++)
			{
				var r:Vector.<int> = new Vector.<int>();
				for (var j:int=0;j<map[i].length;j++)
				{
					r.push(map[i][j]);
				}
				g.map.push(r);
			}
			
			for (i=0;i<blocks.length;i++)
			{
				g.blocks.push(blocks[i].Copy());				
			}
			
			g.player=player.Copy();
			g.progress=progress;
			g.number=number;
			return g;
		}
	}
}