package
{
	import com.greensock.TweenLite;
	import com.greensock.TweenMax;
	import com.greensock.plugins.HexColorsPlugin;
	import com.greensock.plugins.TweenPlugin;
	
	import flash.display.Shader;
	import flash.filters.ShaderFilter;
	
	import org.flixel.*;
	import org.flixel.system.FlxList;

	public class GameState extends FlxState
	{			
		
		[Embed(source="data/player.png")]
		public static var ImgPlayer:Class;
		[Embed(source="data/tiles.png")]
		public static var ImgTiles:Class;
		[Embed(source="data/rock.png")]
		public static var ImgRock:Class;
		
		
		[Embed(source="data/shack.png")]
		public static var ImgShack:Class;
		
		[Embed(source="data/finished2.mp3")]
		public static var SndFinished:Class;
		
		
		[Embed(source="data/move.mp3")]
		public static var SndMove:Class;
		
		[Embed(source="data/push.mp3")]
		public static var SndPush:Class;
		
		[Embed(source="data/pingsm.mp3")]
		public static var SndPingLow:Class;
		
		[Embed(source = 'data/level0.txt', mimeType = "application/octet-stream")] 
		public var TxtLevel0:Class;
		[Embed(source = 'data/level1.txt', mimeType = "application/octet-stream")] 
		public var TxtLevel1:Class;
		[Embed(source = 'data/level2.txt', mimeType = "application/octet-stream")] 
		public var TxtLevel2:Class;
		[Embed(source = 'data/level3.txt', mimeType = "application/octet-stream")] 
		public var TxtLevel3:Class;
		[Embed(source = 'data/level4.txt', mimeType = "application/octet-stream")] 
		public var TxtLevel4:Class;
		[Embed(source = 'data/level5.txt', mimeType = "application/octet-stream")] 
		public var TxtLevel5:Class;
		[Embed(source = 'data/level6.txt', mimeType = "application/octet-stream")] 
		public var TxtLevel6:Class;
		[Embed(source = 'data/level7.txt', mimeType = "application/octet-stream")] 
		public var TxtLevel7:Class;
		[Embed(source = 'data/level8.txt', mimeType = "application/octet-stream")] 
		public var TxtLevel8:Class;
		[Embed(source = 'data/level9.txt', mimeType = "application/octet-stream")] 
		public var TxtLevel9:Class;
		[Embed(source = 'data/level10.txt', mimeType = "application/octet-stream")] 
		public var TxtLevel10:Class;
		
		private var mapsprites:FlxGroup;
		
		private var map:FlxTilemap;
		
		private var game:Game;
		
		public var undos:Vector.<Game>;
		
		public var revealednumber:String;
		
		public var revealednumbertxt:FlxText;
		public var numberline:String;
		
		
		private function revealnumber():void
		{
			revealednumber="";
			for (var i:int=0;i<game.number.length;i++)
			{
				revealednumber+= i<game.progress ? game.number.charAt(i) : "*";
			}
			revealednumbertxt.text=revealednumber;
		}
			
		private var gamegrp:FlxGroup;
		
		override public function create():void
		{	
			super.create();
			gamegrp  = new FlxGroup();
			add(gamegrp);
			
			//FlxG.level=6;
			revealednumbertxt = new FlxText(0,100,FlxG.width,"");
			revealednumbertxt.color=0xffffffff;
			add(revealednumbertxt);
			
			undos = new Vector.<Game>();
			
			if (FlxG.level>=0 && FlxG.level<=6)
			{
				if (this.hasOwnProperty("TxtLevel"+FlxG.level))
				{
					var c:Class = this["TxtLevel"+FlxG.level];
					game = new Game(new c());
					game.generatenumber();
					updateVisuals();
				}
			}
			else
			{
				FlxG.level=0;
				FlxG.switchState(new TitleState());
				
			}
		}
		
		public function updateVisuals():void
		{
			
			if (map!=null)
			{
				gamegrp.remove(map,true);
			}
			if (mapsprites!=null)
			{
				gamegrp.remove(mapsprites,true);
			}
			
			map = new FlxTilemap();
			map.loadMap(game.MapString(),ImgTiles,Game.tilesize,Game.tilesize);
			gamegrp.add(map);		
			mapsprites = new FlxGroup();
			gamegrp.add(mapsprites);
			for each (var s:FlxSprite in game.GenSprites())
			{
				mapsprites.add(s);
			}
			revealnumber();		
		}
		
		private var won:Boolean=false;
		private var fading:Boolean=false;
		
		private function FadeComplete():void
		{			
			FlxG.level++;
			
			var save:FlxSave = new FlxSave();			
			if (save.bind("CB"))
			{
				save.data.level=FlxG.level;					
			}
			
			
			CutSceneState.cutscene=FlxG.level;
			FlxG.switchState(new CutSceneState());
		}
		
		override public function update():void
		{
			/*
			if (FlxG.keys.justPressed("O"))
			{
				FlxG.level--;
				FlxG.switchState(new GameState());
				super.update();
				return;
			}
			if (FlxG.keys.justPressed("P"))
			{
				FlxG.level++;
				
				var save:FlxSave = new FlxSave();			
				if (save.bind("CB"))
				{
					save.data.level=FlxG.level;					
				}
				
				FlxG.switchState(new GameState());
				super.update();
				return;
			}*/
			
			var oldprogress:int=game.progress;
			
			var modified:Boolean=false;
			var last:Game;
			game.needsupdate=false;
			if (TweenMax.getAllTweens().length>0)
			{
				
			}	
			else if (fading)
			{
				
			}
			else if (won)
			{				
				fading=true;
				var s:FlxSound = FlxG.play(SndFinished,TitleState.sfxv);
				s.survive=true;
				FlxG.fade(0xff000000,0.5,FadeComplete,true);
			}		
			else if (FlxG.keys.justPressed("R"))
			{
				FlxG.switchState(new GameState());
			}		
			
			else if (FlxG.keys.justPressed("Z"))
			{
				if (undos.length>0)
				{
					game=undos.pop();
					updateVisuals();
				}
			}
			else if (FlxG.keys.UP)
			{				
				game.ClearMoved();				
				last = game.Copy();
				modified = game.TryMove(game.player, FlxObject.UP,true);
				won=game.ProcessMoves();
			}
			else if (FlxG.keys.DOWN)
			{
				game.ClearMoved();
				last = game.Copy();
				modified = game.TryMove(game.player, FlxObject.DOWN,true);
				won=game.ProcessMoves();	
			}
			else if (FlxG.keys.LEFT)
			{
				game.ClearMoved();
				last = game.Copy();
				modified = game.TryMove(game.player, FlxObject.LEFT,true);
				won=game.ProcessMoves();
			}
			else if (FlxG.keys.RIGHT)
			{
				game.ClearMoved();
				last = game.Copy();
				modified = game.TryMove(game.player, FlxObject.RIGHT,true);
				won=game.ProcessMoves();
			}
			
			if (modified || game.needsupdate)
			{
				game.needsupdate=false;
				undos.push(last);
				
				updateVisuals();	
				if (TweenMax.getAllTweens().length>1)
				{
					FlxG.play(SndPush,TitleState.sfxv);
				}
				else 
				{
					FlxG.play(SndMove,TitleState.sfxv);
				}			
			}
			
			if (game.progress>oldprogress)
			{
				FlxG.play(SndPingLow,TitleState.sfxv);
			}
			super.update();
		}		
	}
}